require ("player")
require ("scripts")
require ("ent")
require ("guns")

bullets = {}
bullets.rifle = {}
bullets.pistol = {}
bullets.tranq = {}
shootCD = 0
shootCDP = 0.05

function setshootCD()
  if player.gun == "pistol" then
    return 0.5
  end
  if player.gun == "rifle" then
    return 0.05
  end
end

function getshootCD()
  return shootCD
end

function shoot(dt)
  getshootCD()
  shootCD = math.max(0, shootCD - dt)
  reloadCD = math.max(0, reloadCD - dt)
  if guns.rifle.clipCount == 0 then
    player.reload(dt, "rifle")
  end
  mousey = love.mouse.getY()
  mousex = love.mouse.getX()
  mousex, mousey = toWorldCoords(mousex, mousey)
  if player.gun == "rifle" then
    if love.mouse.isDown(1) and ent.gun.clipCount > 0 and shootCD == 0 and reloading == false and reloadCD == 0 and canshoot == true then
      local dir = math.atan2(mousey - (player.y + player.h/2), mousex - (player.x + player.w/2))
        table.insert(bullets.rifle, {
          x = player.x + player.w,
          y = player.y,
          w = 4,
          h = 2,
          dir = dir,
          dmg = 20,
          speed = 800
        })
      guns.rifle.clipCount = guns.rifle.clipCount - 1
      shootCD = shootCDP
    end
  end
end

function love.mousepressed(x, y, button)
  if button == 1 and player.gun == "pistol" then
    reloadCD = math.max(0, reloadCD - love.timer.getDelta())
    if guns.pistol.clipCount == 0 then
      player.reload(dt, "pistol")
    end
    if guns.pistol.clipCount > 0 and reloading == false and reloadCD == 0 then
      local dir = math.atan2(mousey - player.y, mousex - player.x)
      table.insert(bullets.pistol, {
      x = player.x + (player.w/2),
      y = player.y + (player.h/2),
      w = 4,
      h = 2,
      dir = dir,
      dmg = 5,
      speed = 800})
      guns.pistol.clipCount = guns.pistol.clipCount - 1
    end
  end
  if button == 1 and player.gun == "tranq" then
    reloadCD = math.max(0, reloadCD - love.timer.getDelta())
    if guns.tranq.clipCount == 0 then
      player.reload(dt, "tranq")
    end
    if guns.tranq.clipCount > 0 and reloading == false and reloadCD == 0 then
      local dir = math.atan2(mousey - player.y, mousex - player.x)
      table.insert(bullets.tranq, {
        x = player.x + player.w,
        y = player.y,
        w = 4,
        h = 2,
        dir = dir,
        dmg = 0,
        stamdmg = 100,
        speed = 1000})
        guns.tranq.clipCount = guns.tranq.clipCount - 1
    end 
  end
end
  
function bulletupdate(dt)
    local i, v
    for i,v in ipairs(bullets.rifle) do
      v.x = v.x + math.cos(v.dir) * v.speed * dt
      v.y = v.y + math.sin(v.dir) * v.speed * dt
      if (v.x < (player.x - width/2) - 10) or (v.x > (player.x + width/2) + 10) or (v.y < (player.y - height/2) -10) or (v.y > (player.y + height/2) + 10) then
        table.remove(bullets.rifle, i)
      end
    end
    local ii, vv
    for ii,vv in ipairs(bullets.pistol) do
      vv.x = vv.x + math.cos(vv.dir) * vv.speed * dt
      vv.y = vv.y + math.sin(vv.dir) * vv.speed * dt
      if (vv.x < (player.x - width/2) - 10) or (vv.x > (player.x + width/2) + 10) or (vv.y < (player.y - height/2) -10) or (vv.y > (player.y + height/2) + 10) then
        table.remove(bullets.pistol, ii)
      end
    end
    local iii,vvv
    for iii,vvv in ipairs(bullets.tranq) do
      vvv.x = vvv.x + math.cos(vvv.dir) * vvv.speed * dt
      vvv.y = vvv.y + math.sin(vvv.dir) * vvv.speed * dt
      if (vvv.x < (player.x - width/2) - 10) or (vvv.x > (player.x + width/2) + 10) or (vvv.y < (player.y - height/2) -10) or (vvv.y > (player.y + height/2) + 10) then
        table.remove(bullets.tranq, iii)
      end
    end
end

function bulletdraw()
  love.graphics.setColor(255, 255, 255)
    local i, v
    for i, v in ipairs(bullets.rifle) do
      love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
    end
    local ii, vv 
    for ii, vv in ipairs(bullets.pistol) do
      love.graphics.rectangle("fill", vv.x, vv.y, vv.w, vv.h)
    end
    local iii,vvv
    for iii, vvv in ipairs(bullets.tranq) do
      love.graphics.setColor( 0, 191, 255, 255)
      love.graphics.rectangle("fill", vvv.x, vvv.y, vvv.w, vvv.h)
    end
  end

function reloadbar()
  local reload = reloadCD
  local reloadcooldown = reloadCDP
  local reloadratio = (reload*10/reloadcooldown)/10
  love.graphics.setColor(200, 200, 200)
  love.graphics.rectangle("fill", player.x , player.y - 10, 50*(reloadratio) , 5)
end
