require ("scripts")
ent = {}
ent.enemies = {}
ent.enemies.x = 300
ent.enemies.y = 300
ent.enemies.w = 32
ent.enemies.h = 32
ent.enemies.v = 100
ent.enemies.health = 100
ent.enemies.life = nil
ent.enemies.drop = nil
ent.enemies.shootCD = 0
ent.enemies.shootCDP = 0.5
ent.enemies.gun = {}
ent.enemies.gun.clipCount = 30
ent.enemies.gun.maxclipCount = 30
ent.enemies.gun.ammoCount = 500
ent.enemies.gun.maxammoCount = 500

ent.enemies.bullets = {}

ent.item = {}
ent.item.ammo = {}
ent.item.ammo.x = 70
ent.item.ammo.y = 100
ent.item.ammo.w = 16
ent.item.ammo.h = 16
ent.item.ammo.rarity = 50
ent.item.ammo.p = true

ent.item.hp = {}
ent.item.hp.rarity = 50

ammodrop = false
hpdrop = false

ent.gun = {}
ent.gun.clipCount = 30
ent.gun.maxclipCount = 30
ent.gun.amCount = 120
ent.gun.maxamCount = 120
pickUp = false
ammoChance = math.random(100, 1)
hpChance = math.random(100,1)



function enemyDraw()
  local i,v
  for i,v in ipairs(ent.enemies) do
    if v.health > 0 then
      v.life = true
      if isenemyHit() then 
        love.graphics.setColor(255, 0, 0)
        love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
      else 
        love.graphics.setColor(200, 0, 0)
        love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
      end
      local health = math.floor(v.health)
      local maxhealth = v.maxhealth
      local healthratio = (health*10/maxhealth)/10
      local stam = math.floor(v.stamhealth)
      local maxstam = math.floor(v.maxstamhealth)
      local stamratio = math.floor(stam*10/maxstam)/10
      
      love.graphics.setColor(255, 0, 0)
      love.graphics.print(v.name .. ": " .. health .. " " .. healthratio, v.x, v.y-40)
      
      love.graphics.setColor(200*(1-healthratio), 200*(healthratio), 0, 200)
      love.graphics.rectangle("fill", v.x, v.y - 20, 100*healthratio, 2)
      
      love.graphics.setColor(0, 191, 255, 200)
      love.graphics.rectangle("fill", v.x, v.y+ 5 - 20, 100*stamratio, 2)
      

    end
    if v.awake == false then
      love.graphics.setColor(0, 0, 150)
      love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
    end
  end
end


function isenemyHit()
  if player.gun == "rifle" then
    local i,v
    for i,v in ipairs(bullets.rifle) do
      local k,p
      for k,p in ipairs(ent.enemies) do
        if checkCollision(p.x, p.y, p.w, p.h, v.x, v.y, v.w, v.h) then
          table.remove(bullets.rifle, i)
          p.health = math.floor(p.health - v.dmg)
          print(v.dmg)
          print(p.health)
          if p.health <= 0 then
            p.health = 0
            p.life = false
          end
          return true
        end
      end
    end
  end
  if player.gun == "pistol" then
    local i,v
    for i,v in ipairs(bullets.pistol) do
      local k,p
      for k,p in ipairs(ent.enemies) do
        if checkCollision(p.x, p.y, p.w, p.h, v.x, v.y, v.w, v.h) then
          table.remove(bullets.pistol, i)
          p.health = math.floor(p.health - v.dmg)
          print(v.dmg)
          print(p.health)
          if p.health <= 0 then
            p.health = 0
            p.life = false
          end
          return true
        end
      end
    end
  end
  if player.gun == "tranq" then
    local i,v
    for i,v in ipairs(bullets.tranq) do
      local k,p
      for k,p in ipairs(ent.enemies) do
        if checkCollision(p.x, p.y, p.w, p.h, v.x, v.y, v.w, v.h) then
          table.remove(bullets.tranq, i)
          p.stamhealth = math.floor(p.stamhealth - v.stamdmg)
          print(p.stamhealth)
          if p.stamhealth <= 0 then
            p.stamhealth = 0
            p.awake = false
          end
          return true
        end
      end
    end
  end
end

function enemyGen(x, y, name, entype)
  local posx = x
  local posy = y
  local n = name
  local health = hp
  local variant = entype
  local count = 0
  if variant == "normal" then
    table.insert(ent.enemies, { name = n,
                                startx = posx,
                                starty = posy,
                                x = posx,
                                y = posy,
                                w = 32,
                                h = 32,
                                s = 100,
                                bw = 8,
                                bh = 8,
                                bs = 1000,
                                shootCD = 0,
                                shootCDP = 0.05,
                                reloadCD = 0,
                                reloadCDP = 0.5,
                                health = 100,
                                maxhealth = 100,
                                stamhealth = 100,
                                maxstamhealth = 100,
                                damage = 0.5,
                                life = true,
                                awake = true,
                                gun = { clipCount = 30,
                                        maxclipCount = 30,
                                        amCount = 120,
                                        maxamCount = 120}})
  count = count + 1
  end
  if variant == "boss" then
    table.insert(ent.enemies, { name = n,
                                startx = posx,
                                starty = posy,
                                x = posx,
                                y= posy,
                                w = 64,
                                h = 64,
                                s = 100,
                                bw = 8,
                                bh = 8,
                                bs = 800,
                                shootCD = 0,
                                shootCDP = 0.05,
                                reloadCD = 0,
                                reloadCDP = 1,
                                health = 2000,
                                maxhealth = 2000,
                                stamhealth = 200,
                                maxstamhealth = 200,
                                damage = 5,
                                life = true,
                                awake = true,
                                gun = { clipCount = 240,
                                        maxclipCount = 240,
                                        amCount = 2000,
                                        maxamCount = 2000}})
  count = count + 1
  end
end
  
function enemyupdate(dt)
  local i,v
  for i,v in ipairs(ent.enemies) do
      if math.floor(v.health) == 0 and v.life == false then
        print("ammo chance " .. ammoChance .. " hp chance " .. hpChance)
        if ammoChance <= ent.item.ammo.rarity then
          itemGen(v.x, v.y, "ammo")
          ammodrop = true
          ammoChance = 0
       end
       if hpChance <= ent.item.hp.rarity then
         itemGen(v.x+10, v.y+10, "health")
         hpdrop = true
         hpChance = 0
      end
      if hpdrop == true or ammodrop == true then
        table.remove(ent.enemies, i)
        hpdrop = false
        ammodrop = false
      else
        table.remove(ent.enemies,i)
      end
    end
    if v.awake == true then
      v.shootCD = math.max(0, v.shootCD - dt)
      v.reloadCD = math.max(0, v.reloadCD - dt)
      if v.shootCD == 0 and v.gun.clipCount > 0 and v.reloadCD == 0 then
        local dir = math.atan2((player.y + (player.h/2)) - v.y, (player.x + (player.w/2)) - v.x)
        if canEnemySee(v.name) == true then
          table.insert(ent.enemies.bullets, {
            x = v.x + v.w,
            y = v.y,
            w = v.bw,
            h = v.bh,
            dir = dir,
            dmg = v.damage,
            speed = v.bs})
            v.shootCD = v.shootCDP
            v.gun.clipCount = v.gun.clipCount - 1
        end
      end
      if v.gun.clipCount == 0 and v.gun.amCount > 0 then
        if v.gun.amCount >= v.gun.maxclipCount then
          v.gun.amCount = v.gun.amCount - v.gun.maxclipCount
          v.gun.clipCount = v.gun.maxclipCount
          v.reloadCD = v.reloadCDP
        else
          local reloadAmount = v.gun.amCount
          v.gun.clipCount = v.gun.clipCount + v.gun.amCount
          v.reloadCD = v.reloadCDP
        end
      end
    end
  end
end

function enemymovupdate(dt)
  enemymovement("grunt", 200, dt)
end

function enemybulletupdate(dt)
  local i,v
  for i,v in ipairs(ent.enemies.bullets) do
    v.x = v.x + math.cos(v.dir) * v.speed * dt
    v.y = v.y + math.sin(v.dir) * v.speed * dt
    if (v.x < (player.x - width/2) - 10) or (v.x > (player.x + width/2) + 10) or (v.y < (player.y - height/2) -10) or (v.y > (player.y + height/2) + 10) then
      table.remove(ent.enemies.bullets, i)
    end
  end
end

function enemybulletdraw()
  love.graphics.setColor(255, 0, 0, 200)
  local i,v
  for i,v in ipairs(ent.enemies.bullets) do
    love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
  end
end

function itemDraw()
  local i,v
  for i,v in ipairs(ent.item.ammo) do
    if v.p == true then
      love.graphics.setColor(200, 200, 200, 255)    
      love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)    
    end
  end
  local k,p
  for k,p in ipairs(ent.item.hp) do
    if p.p == true then
      love.graphics.setColor(0, 200, 0 ,255)
      love.graphics.rectangle("fill", p.x, p.y, p.w, p.h)
    end
  end
end

function itemGen(x, y, item)
  local posx = x
  local posy = y
  if item == "ammo" then
    table.insert(ent.item.ammo, { x = posx,
                                  y = posy,
                                  w = ent.item.ammo.w,
                                  h = ent.item.ammo.h,
                                  r = ent.item.ammo.rarity,
                                  p = true})
  end
  if item == "health" then
    table.insert(ent.item.hp, {   x = posx,
                                  y = posy,
                                  w = 16,
                                  h = 16,
                                  r = 70,
                                  hp = 50,
                                  p = true})
  end  
end
  
function ammoUpdate(dt)
  if guns.rifle.amCount > guns.rifle.maxamCount then
      guns.rifle.amCount = guns.rifle.maxamCount
  end
  if guns.pistol.amCount > guns.pistol.maxamCount then
      guns.pistol.amCount = guns.pistol.maxamCount
  end
  if guns.tranq.amCount > guns.tranq.maxamCount then
      guns.tranq.amCount = guns.tranq.maxamCount
  end
  local i,v
  for i,v in ipairs(ent.item.ammo) do
    if checkCollision(getplayerX(), getplayerY(), getplayerW(), getplayerH(), v.x, v.y, v.w, v.h) and v.p == true then
      if isfullR() == false then
          guns.rifle.amCount = guns.rifle.amCount + 60
          guns.pistol.amCount = guns.pistol.amCount + 60
          guns.tranq.amCount = guns.tranq.amCount + 60
          table.remove(ent.item.ammo, i)
      end
    end
  end
end

function hpUpdate(dt)
  
  if player.health < 100 then
    canpickHP = true
  else
    canpickHP = false
  end
  if canpickHP == true then
    local i,v 
    for i,v in ipairs(ent.item.hp) do
      if checkCollision(player.x, player.y, player.w, player.h, v.x, v.y, v.w, v.h) then
        player.health = player.health + 50
        table.remove(ent.item.hp, i)
      end
    end
  end
  if player.health > player.maxhealth then
    player.health = player.maxhealth
  end
end
