function love.load()
  require ("player")
  require ("bullet")
  require ("scripts")
  require ("ent")
  require ("camera")
  require ("guns")
  require ("fonts")
  love.mouse.setVisible(false)
  width = love.graphics.getWidth()
  height = love.graphics.getHeight()
  
  camera:setBounds(-10*width, -10*height, width, height)
  game = {}
  game.state = "game"
  itemGen(ent.item.ammo.x, ent.item.ammo.y, "ammo")
  itemGen(ent.item.ammo.x + 50, ent.item.ammo.y + 50, "health")
  enemyGen(1000, 500, "raid boss", "boss")
  rng = love.math.newRandomGenerator()
  enemyGen(1000, 700, "grunt", "normal")
end

function love.draw(dt)
  if game.state == "game" then
    camera:set()
    playerlife()
    love.graphics.setColor(255, 255, 255)
    if player.gun == "rifle" then
      love.graphics.draw(rifleimg, (player.x - width / 2) +20, (player.y + height / 2) - 500)
      love.graphics.print("Ammo: " .. guns.rifle.clipCount .. " " .. guns.rifle.amCount .. " gun: ".. player.gun, (player.x - width / 2) +20, (player.y + height / 2) - 30)
    elseif player.gun == "pistol" then
      love.graphics.print("Ammo: " .. guns.pistol.clipCount .. " " .. guns.pistol.amCount .. " gun: ".. player.gun, (player.x - width / 2) +20, (player.y + height / 2) - 30)
    elseif player.gun == "tranq" then
      love.graphics.print("Ammo: " .. guns.tranq.clipCount .. " " .. guns.tranq.amCount .. " gun: ".. player.gun, (player.x - width / 2) +20, (player.y + height / 2) - 30)
    end
    reloadbar()
     if reloadCD == 0 then
      reloading = false
    end
    
    love.graphics.setColor(255, 255, 255)
    player.draw(dt)
    
    love.graphics.setColor(128, 128, 128)
    bulletdraw()
    
    enemyDraw()
    enemybulletdraw()
    
    itemDraw()
    crosshair()
    camera:unset()
  end
  if game.state == "death" then
    love.graphics.print( "You're dead, "..player.name.."!", love.graphics.getWidth()/2 - 200, love.graphics.getHeight()/2, 0, 2, 2, 0, 0, 0, 0 )
  end
end

function love.update(dt)
  stateUpdate()
  function love.keypressed(key)
    if key == "1" then
      player.gun = "rifle"
    end
    if key == "2" then
      player.gun = "pistol"
    end
    if key == "3" then
      player.gun = "tranq"
    end
    if key == "escape" then
        love.event.quit()
    end
    if game.state == "game" and player.gun == "rifle" then
      if key == "r" and guns.rifle.amCount > 0 then
        if riflefullClip == false then
          player.reload(dt, "rifle")
        end
      end
    elseif game.state == "game" and player.gun == "pistol" then
      if key == "r" and guns.pistol.amCount > 0 then
        if pistolfullClip == false then
          player.reload(dt, "pistol")
        end
      end
    elseif game.state == "game" and player.gun == "tranq" then
      if key == "r" and guns.tranq.amCount > 0 then
        if tranqfullClip == false then
          player.reload(dt, "tranq")
        end
      end
    end
    if game.state == "death" then
      if key == "r" then
        game.state = "game"
      end
    end
  end

  if game.state == "game" then
    hpUpdate()
    playerUpdate(dt)
    isFull()
    isenemyHit()
    isplayerHit()
    player.move(dt)
    bulletupdate(dt)
    shoot(dt)
    ammoUpdate(dt)
    enemyupdate(dt)
    enemybulletupdate(dt)
    enemymovupdate(dt)
    chanceGen()
    shootCDP = setshootCD()
    end
  if game.state == "death" then
  end
end
