require ("guns")
player = {}
player.name = "Joe"
player.direction = "right"
player.health = 100
player.maxhealth = 100
player.x = love.graphics.getWidth()/2 - 52.5
player.y = love.graphics.getHeight()/2 - 31.5
player.h = 32
player.w = 32
player.v = 200
player.gun = "rifle"
player.death = false
reloading = false
canpickUp = true
reloadCD = 0
reloadCDP = 1
canshoot = true

function getplayerX()
  return player.x
end

function getplayerY()
  return player.y
end

function getplayerW()
  return player.w
end

function getplayerH()
  return player.h
end

function setplayerHealth(value)
  player.health = player.health - value
end

function player.move(dt)
  if love.keyboard.isDown("d") then
    player.x = player.x + (player.v*dt)
  end
  if love.keyboard.isDown("w") then
    player.y = player.y - (player.v*dt)
  end
  if love.keyboard.isDown("a") then
    player.x = player.x - (player.v*dt)
  end
  if love.keyboard.isDown("s") then
    player.y = player.y + (player.v*dt)
  end
end

function getplayerDirection()
  if love.keyboard.isDown("d") then
    return "right"
  end
  if love.keyboard.isDown("a") then
    return "left"
  end
  if love.keyboard.isDown("s") then
    return "down"
  end
  if love.keyboard.isDown("w") then
    return "up"
  end
end

function player.draw()
  local mousex, mousey = love.mouse.getPosition()
  mousex, mousey = toWorldCoords(mousex, mousey)
  local playerangle = math.atan2(mousey - player.y, mousex - player.x)
    love.graphics.draw(player.img, player.x, player.y, playerangle, 1, 1, 52.5, 31.5)
end

function player.reload(dt, gun)
  if gun == "rifle" then
    if (guns.rifle.amCount >= 0) and (guns.rifle.clipCount < 30) and reloading == false and riflefullClip == false then
      reloadAmount = guns.rifle.maxclipCount - guns.rifle.clipCount
      
      if reloadAmount > guns.rifle.amCount then
        reloadAmount = guns.rifle.amCount
      end
      
      guns.rifle.amCount = guns.rifle.amCount - reloadAmount
      if guns.rifle.amCount < 0 then
        guns.rifle.amCount = 0
      end
      
      guns.rifle.clipCount = guns.rifle.clipCount + reloadAmount
      reloading = true
      
    end
    reloadCD = reloadCDP
  elseif gun == "pistol" then
    if (guns.pistol.amCount >= 0) and (guns.pistol.clipCount < 30) and reloading == false and pistolfullClip == false then
      reloadAmount = guns.pistol.maxclipCount - guns.pistol.clipCount
      
      if reloadAmount > guns.pistol.amCount then
        reloadAmount = guns.pistol.amCount
      end
      
      guns.pistol.amCount = guns.pistol.amCount - reloadAmount
      if guns.pistol.amCount < 0 then
        guns.pistol.amCount = 0
      end
        
      guns.pistol.clipCount = guns.pistol.clipCount + reloadAmount
      reloading = true
        
    end
    reloadCD = reloadCDP
  elseif gun == "tranq" then
    if (guns.tranq.amCount >= 0) and (guns.tranq.clipCount < 30) and reloading == false and tranqfullClip == false then
      reloadAmount = guns.tranq.maxclipCount - guns.tranq.clipCount
      
      if reloadAmount > guns.tranq.amCount then
        reloadAmount = guns.tranq.amCount
      end
      
      guns.tranq.amCount = guns.tranq.amCount - reloadAmount
      if guns.tranq.amCount < 0 then
        guns.tranq.amCount = 0
      end
        
      guns.tranq.clipCount = guns.tranq.clipCount + reloadAmount
      reloading = true
      
        
    end
    reloadCD = reloadCDP
  end
end

function playerlife()
  local health = math.floor(player.health)
  local maxhealth = player.maxhealth
  local healthratio = (health*10/maxhealth)/10
  local name = player.name
  local width = love.graphics.getWidth()
  local height = love.graphics.getHeight()
  
  if healthratio < 0 then
    healthratio = 0
  end
  
  if health < 0  then
    health = 0
  end
  
  love.graphics.setColor(100, 100, 100, 200)
  love.graphics.rectangle("line", (player.x - width/2) + 10, (player.y - height / 2) + 20, 250, 12)
  
  love.graphics.setColor(200*(1-healthratio), 200*healthratio, 0, 200)
  love.graphics.rectangle("fill",(player.x - width/2) + 11, (player.y - height / 2) + 21, 248*healthratio, 10)
  
  love.graphics.print("HP: " ..health .." "..name, (player.x - width/2) + 11, (player.y - height / 2) + 40)
  
end

function isplayerHit()
  local i,v
  for i,v in ipairs(ent.enemies.bullets) do
    local k,p
    for k,p in ipairs(ent.enemies) do
      if checkCollision(getplayerX(), getplayerY(), getplayerW(), getplayerH(), v.x, v.y, v.w, v.h) and p.life == true then
        setplayerHealth(v.dmg)
        table.remove(ent.enemies.bullets, i)
        return true
      end
    end
  end
end

function playerUpdate(dt)
  local cspeed = player.v * dt
  local name = player.name 
  local health = player.health
  local maxhealth = player.maxhealth
  local healthratio = math.floor(health*10/maxhealth)/10
  
  camera:setPosition(player.x - love.graphics.getWidth() / 2, player.y - love.graphics.getHeight() / 2)
  if healthratio < 0 then
    game.state = "death"
  end
  
  if player.gun == "rifle" then
    player.img = love.graphics.newImage("assets/Top_Down_Survivor/rifle/idle/survivor-idle_rifle_0.png", linear)
  elseif player.gun == "pistol" then
    player.img = love.graphics.newImage("assets/Top_Down_Survivor/handgun/idle/survivor-idle_handgun_0.png", linear)
  end

end
