require("camera")
ch_size = 10
ch_gap = 5
function checkCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function chanceGen()
  ammoChance = math.random(100,1)
  hpChance = math.random(100,1)
end

function getgameState()
  local state = game.state
  print(state)
  return state
end

function stateUpdate()
  
  if player.health == 0 then
    game.state = "death"
  else
    game.state = "game"
  end
end

function toWorldCoords(x,y)
    x = x + (camera._x)
    y = y + (camera._y)
    return x,y
end

function canEnemySee(arg)
  local name = arg
  local i,v
  for i,v in ipairs(ent.enemies) do
    if v.name == name then
      if (v.x < camera._x + love.graphics.getWidth()) and (v.x > camera._x) and (v.y < camera._y + love.graphics.getHeight()) and (v.y > camera._y) then
        local dir = math.atan2((player.y + (player.h/2)) - v.y, (player.x + (player.w/2)) - v.x)
        local angle = (dir * (180/math.pi))
        if angle < 45 and angle > - 45 then
          return true
        else
          return false
        end
      end
    end
  end
end

function enemymovement(name, distance, dt)
  local i,v
  for i,v in ipairs(ent.enemies) do
    if v.name == name and v.awake == true and canEnemySee(name) == false then
      if v.y >= (v.starty - distance) then
        v.y = v.y + (v.s*dt)
      end
    end
  end
end

function crosshair()
  local mousex, mousey = love.mouse.getPosition()
  mousex, mousey = toWorldCoords(mousex, mousey)
  local size = ch_size
  local gap = ch_gap
  local x1 = mousex
  local y1 = mousey + size
  local x2 = mousex
  local y2 = mousey + gap
  local x3 = mousex - size
  local y3 = mousey
  local x4 = mousex - gap
  local y4 = mousey
  local x5 = mousex + size
  local y5 = mousey
  local x6 = mousex + gap
  local y6 = mousey
  local x7 = mousex
  local y7 = mousey - size
  local x8 = mousex
  local y8 = mousey - gap
  if player.gun == "tranq" then
    r = 0
    g = 150
    b = 255
  elseif player.gun == "pistol" then
    r = 200
    g = 50
    b = 20
  elseif player.gun == "rifle" then
    r = 255
    g = 0
    b = 0
  end
  love.graphics.setColor(r, g, b)
  love.graphics.line(x1, y1, x2, y2)
  love.graphics.line(x3, y3, x4, y4)
  love.graphics.line(x5, y5, x6, y6)
  love.graphics.line(x7, y7, x8, y8)
end
